package reverse;

import integratedtoolkit.types.annotations.Constraints;
import integratedtoolkit.types.annotations.Method;
import integratedtoolkit.types.annotations.Parameter;
import integratedtoolkit.types.annotations.Parameter.Direction;
import integratedtoolkit.types.annotations.Parameter.Type;

public interface ReverseItf {

	@Method(declaringClass = "reverse.ReverseImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 0.5f)
	void parse(@Parameter(type = Type.STRING, direction = Direction.IN) String fileName,
			@Parameter(type = Type.FILE, direction = Direction.IN) String html,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String count);

	@Method(declaringClass = "reverse.ReverseImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 0.5f)
	void parseDir(@Parameter(type = Type.STRING, direction = Direction.IN) String directory,
			@Parameter(type = Type.INT, direction = Direction.IN) int begin,
			@Parameter(type = Type.INT, direction = Direction.IN) int end,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String result,
			@Parameter(type = Type.BOOLEAN, direction = Direction.IN) boolean debug);

	@Method(declaringClass = "reverse.ReverseImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 0.5f)
	void mergeFiles(@Parameter(type = Type.FILE, direction = Direction.INOUT) String f1,
			@Parameter(type = Type.FILE, direction = Direction.IN) String f2);

	@Method(declaringClass = "reverse.ReverseImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 0.5f)
	void mergePackage(@Parameter(type = Type.FILE, direction = Direction.IN) String pack,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String indexes);
}
